import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt

mpl.rcParams['font.family'] = 'serif'
mpl.rcParams['text.usetex'] = True
mpl.rcParams['text.latex.preamble'] = r'\usepackage{pxfonts}'

c1 = (1, 0.3, 0.3)
c2 = (0.3, 0.3, 1)
c3 = (0.3, 0.6, 0.3)
f0, n0 = np.loadtxt('SCRN0200.TXT', unpack=1)[:,1:]
f1, n1 = np.loadtxt('SCRN0201.TXT', unpack=1)[:,20:]
f2, n2 = np.loadtxt('SCRN0202.TXT', unpack=1)[:,20:]
f3, n3 = np.loadtxt('SCRN0203.TXT', unpack=1)[:,20:]
fd0, d0 = np.loadtxt('SCRN0207.TXT', unpack=1)[:,1:]
fd1, d1 = np.loadtxt('SCRN0206.TXT', unpack=1)[:,20:]
fd2, d2 = np.loadtxt('SCRN0205.TXT', unpack=1)[:,20:]
fd3, d3 = np.loadtxt('SCRN0204.TXT', unpack=1)[:,20:]

#ff = np.logspace(-1, 5, 2000)
#dacn = 300e-9*np.abs((1+1j*ff/6)*(1+1j*ff/20)/(1+1j*ff/0.5)/(1+1j*ff/250)
#        *(1+1j*ff/12)/(1+1j*ff/110))*0.268e-3*19.8

plt.figure(figsize=(6,5))
plt.loglog(f0, n0, c=c1, label='Coil noise')
plt.loglog(f1, n1, c=c1)
plt.loglog(f2, n2, c=c1)
plt.loglog(f3, n3, c=c1)
plt.loglog(f0, d0, c=c2, label='SR785 noise')
plt.loglog(f1, d1, c=c2)
plt.loglog(f2, d2, c=c2)
plt.loglog(f3, d3, c=c2)
#plt.loglog(ff, dacn, c=c3, label='Expected DAC noise')
plt.grid('on', which='both', ls='solid', alpha=0.5)
plt.grid(alpha=0.2, which='minor')
plt.xlim(0.09, 1.1e5)
plt.ylim(4e-9, 3e-5)
plt.xlabel('Frequency [Hz]')
plt.ylabel('ASD of voltage [V/Hz$^{1/2}$]')
plt.legend()
plt.title('IX PUM coil spectrum [to satellite box]')
plt.tight_layout()
plt.savefig('IX_coil_voltage.pdf')
